C       **********************************************************
C       ROUTINE TO WRITE N AND K INTO LFILE
C       **********************************************************
        SUBROUTINE SAVEFILE(ZI,NI,KI,M,NAME)
        REAL KI(256),ZI(256),NI(256),HLP
        INTEGER LOGI,M,I
        CHARACTER*64 LFILE
        CHARACTER*10 NAME

11      FORMAT (' File name to store optical constants: ',$)
14      FORMAT (' This file has an illegal extension ! ',/)
30      FORMAT (A64)
100     WRITE (6,11)
        READ (5,30) LFILE
        CALL NAMECHEC(LFILE,NAME,LOGI)
        IF(LOGI.EQ.0) THEN
        WRITE (6,14)
        GOTO 100
        ENDIF
C       *************************************************************
C       TRANSFORMATION DEPENDING ON THE NAMECHECK RESULT
C       *************************************************************
        IF (LOGI.EQ.2) THEN
        DO 300 I=1,M
300     ZI(I)=1.0/ZI(I)
        ELSE IF (LOGI.EQ.3) THEN
        DO 320 I=1,M
        HLP=KI(I)
        KI(I)=2*HLP*NI(I)
320     NI(I)=NI(I)**2-HLP**2
        ENDIF
C       *************************************************************
C       STORAGE PROCESS DEPENDING ON THE NAMECHECK RESULT
C       *************************************************************
        OPEN(12,ERR=150,FILE=LFILE)
21      FORMAT (' ',E11.5,' ',E11.5,' ',E11.5)
        IF(LOGI.EQ.2) THEN
        WRITE (12,21) (ZI(I),NI(I),KI(I),I=M,1,-1)
        ELSE
120     WRITE (12,21) (ZI(I),NI(I),KI(I),I=1,M)
        ENDIF
        CLOSE (12)
        RETURN
13      FORMAT (' There is no access to file       : ',A32)
150     WRITE (6,13) LFILE
        GOTO 100
        END

C       *************************************************************
C       CHECK IF THE FILE IS A ".LNK", ".ZNK" OR ".LEE"-FILE
C       RECOGNITION OF THE TITLE OF THE SPECTRUM
C       *************************************************************
        SUBROUTINE NAMECHEC(FILEN,NAME,LZ)
        INTEGER EXA,NME,LZ
        CHARACTER*10 NAME
        CHARACTER*64 FILEN,HNAME,HFNAME
        CHARACTER*3 EXTENS,EXTL1,EXTL2,EXTZ1,EXTZ2,EXTE1,EXTE2
        DATA EXTL1,EXTL2/'LNK','lnk'/
        DATA EXTZ1,EXTZ2/'ZNK','znk'/
        DATA EXTE1,EXTE2/'LEE','lee'/

        HNAME=FILEN
200     EXA=INDEX(HNAME,'/')+1
        IF (EXA.GT.1) THEN
        HNAME=HNAME(EXA:)
        GOTO 200
        ELSE
        HFNAME=HNAME
        ENDIF

        HNAME=HFNAME
        NME=0
100     EXA=INDEX(HNAME,'.')+1
        IF (EXA.GT.1) THEN
        HNAME=HNAME(EXA:)
        NME=NME+EXA-1
        GOTO 100
        ELSE
        EXTENS=HNAME
        NAME=HFNAME(:MAX0(0,NME-1))
        ENDIF

        LZ=0
        IF(EXTENS.EQ.EXTL1.OR.EXTENS.EQ.EXTL2) LZ=1
        IF(EXTENS.EQ.EXTZ1.OR.EXTENS.EQ.EXTZ2) LZ=2
        IF(EXTENS.EQ.EXTE1.OR.EXTENS.EQ.EXTE2) LZ=3
        RETURN
        END

C	*************************************************************
C	ROUTINE TO PLOT A GRAPHIC OF UP TO 4 GRAPHS
C	*************************************************************
	SUBROUTINE PLOT(XF,YF,MF,N,ORDTIT,ABSTIT,TITLE,KE)
        INTEGER IGRAPH
        INTEGER JAXES,I,J,IX,N,KE
        INTEGER MF(4)
        REAL XF(256,4),YF(256,4),X(256),Y(256)
        REAL XMIN,XMAX,YMIN,YMAX
	CHARACTER*40 TITLE
        CHARACTER*2 ORDTIT
        CHARACTER*10 ABSTIT
C
C	FIND THE MAXIMUM, AND MINIMUM OF THE VECTORS
C
  100 XMIN=XF(1,1)
      XMAX=XF(MF(1),1)
      DO 10 I = 2,N
       IF(XMIN.GT.XF(1,I)) XMIN=XF(1,I)
       IF(XMAX.LT.XF(MF(I),I)) XMAX=XF(MF(I),I)
   10 CONTINUE
      YMIN=YF(1,1)
      YMAX=YMIN
      DO 20 I = 1,N
        DO 20 J=1,MF(I)
        IF(YMIN.GT.YF(J,I)) YMIN=YF(J,I)
        IF(YMAX.LT.YF(J,I)) YMAX=YF(J,I)
   20 CONTINUE
      IF(YMIN.EQ.YMAX) YMAX=YMIN+0.1
C
C	CALCULATE THE BEST KIND OF SCALING
C
      JAXES=0
      IF(YMIN.GT.0.AND.YMAX/YMIN.GT.80.0) JAXES=JAXES+2
      IF(XMIN.GT.0.AND.XMAX/XMIN.GT.80.0) JAXES=JAXES+1
C
C	SET UP THE GRAPH, MODE TO GRAPHICS, DRAW AXES, SET UP SCALE
C
	KE=0
      CALL GRINIT(JAXES,XMIN,YMIN,XMAX,YMAX,KE)
      IF(KE.GT.0)GOTO 900
      CALL GRAXIS(1,ABSTIT)
      CALL GRAXIS(2,ORDTIT)
      CALL GRAXIS(3,TITLE)
C
C	DRAW THE LINES 
C
      DO 200 IGRAPH=1,N
      DO 300 IX=1,MF(IGRAPH)
      X(IX)=XF(IX,IGRAPH)
300   Y(IX)=YF(IX,IGRAPH)
      CALL GRDRAW(IGRAPH,MF(IGRAPH),X,Y)
200   CONTINUE
C
C	GRAPHING COMPLETE, ALLOW KEYBOARD INPUT
C
  400 CALL WAIT
C
C	RETURN SCREEN TO TEXT MODE
C
      CALL GRCLOSE
  900 RETURN
      END

C	*************************************************************
C	FUNCTION VALUES OF THE EXTRAPOLATED FUNCTIONS
C	*************************************************************
	REAL FUNCTION LFUNCT(LC,PARM)
	REAL LC,PARM(6)
	
	IF (PARM(1).LE.2.0) THEN
	LFUNCT=PARM(3)*LC**PARM(2)+PARM(4)
	ELSE
	IF (LC.EQ.0.0) THEN
	LFUNCT=PARM(4)
	ELSE
	LFUNCT=PARM(3)*EXP(-1.0/LC)+PARM(4)
	ENDIF
	ENDIF
	RETURN
	END


	REAL FUNCTION RFUNCT(LC,PARM)
	REAL LC,PARM(6)

	IF (PARM(1).LE.2.0) THEN
	RFUNCT=PARM(3)*LC**PARM(2)+PARM(4)
	ELSE
	RFUNCT=PARM(3)*EXP(-LC)+PARM(4)
	ENDIF
	RETURN
	END

C	*************************************************************
C	LIN. INTERPOLATION OF OPTICAL CONSTANTS BETWEEN GIVEN POINTS
C	*************************************************************
	REAL FUNCTION VALUEAT(LH,NH,LC,INDH)
	INTEGER INDH,I
	REAL LH(256),NH(256)
	REAL LC,A

	I=INDH
210	IF (LH(I).EQ.LC) THEN
	  VALUEAT=NH(I)
	  GOTO 100
	ENDIF
	IF (LH(I).GT.LC) THEN
	  A=(LC-LH(I-1))/(LH(I)-LH(I-1))
	  VALUEAT=NH(I-1)*(1-A)+NH(I)*A
	  GOTO 100
	ENDIF
	I=I+1
	GOTO 210
100	INDH=I
	RETURN
	END

C	*************************************************************
C	INTEGRALS INSIDE THE GIVEN WAVELENGTH RANGE
C	*************************************************************
	REAL*8 FUNCTION CUBINT(KOMP,LC,X1,X2,A1,A2,A3,A4)
	INTEGER KOMP
	REAL*8 LC,X1,X2
	REAL A1,A2,A3,A4

	IF (MOD(KOMP,2).EQ.1) THEN
	CUBINT=0.5D0*LC*(A1*(X2**2-X1**2)+2.0*A2*(X2-X1)+(A3+A1*LC**2)
     % *DLOG((LC**2-X2**2)/(LC**2-X1**2))+(A4/LC+A2*LC)*DLOG((LC-X2)
     % *(LC+X1)/((LC-X1)*(LC+X2))))
	ELSE
	CUBINT=-0.5D0*((A1*LC**2+A3)*LC*DLOG((LC+X1)*(LC-X2)/((LC+X2)
     % *(LC-X1)))+(A2*LC**2)*DLOG((LC**2-X2**2)/(LC**2-X1**2))
     % +2.0*A1*LC**2*(X2-X1)+A4*DLOG(X1**2*(LC**2-X2**2)/
     % (X2**2*(LC**2-X1**2))))
	ENDIF
	RETURN
	END

C       *************************************************************
C       INTEGRAL AT THE LOW WAVELENGTH EDGE
C       *************************************************************
        REAL*8 FUNCTION LINT(KOMP,LC,LMIN,PARM)
        INTEGER KOMP,N,I
        REAL*8 LC,LMIN,INT1,INT2,HINT,C,B,D
        REAL*8 STEP,XU,XV1,XM,XV2,XO
        REAL XUR,XV1R,XMR,XV2R,XOR
        REAL PARM(6),EPS
        REAL LFUNCT
        DATA EPS /1.0E-7/

        IF (PARM(1).EQ.1.0) THEN
C       *************************************************************
C       ANALYTICAL INTEGRATION 
C       EXPONENT INTEGER GE 0
C       *************************************************************
        N=PARM(2)-1+MOD(KOMP,2)
        C=0.5D0*(1+(-1)**N)*LC**N
        B=0.5D0*(1+(-1)**(N-1))*LC**(N-1)
        D=0.0D0
        IF (N.LE.1) GOTO 110
        DO 100 I=0,(N-2)/2
100     D=D+LMIN**(N-2*I-2)*LC**(2*I)/(N-2*I-1)
        D=D*LMIN
110     LINT=-PARM(3)*0.5D0*(C/LC*DLOG((LC-LMIN)/(LC+LMIN))
     % +B*DLOG((LC**2-LMIN**2)/LC**2)+2.0D0*D)
        IF (MOD(KOMP,2).EQ.1)THEN
        LINT=LINT-PARM(4)/(2.0D0*LC)*DLOG((LC-LMIN)/(LC+LMIN))
        LINT=-LINT*LC
        ELSE
        LINT=LINT*LC**2+PARM(5)
        ENDIF
        ELSE
C       ************************************************************
C       NUMERICAL INTEGRATION (SIMPSON RULE)
C       FOR NON-INTEGER EXPONENTS AND EXPONENTIAL FUNCTIONS
C       ************************************************************
C       SCHRITTWEITENABSCHTAEZUNG
C       ************************************************************
        XO=LMIN
        XOR=REAL(XO)
        XU=LMIN-LMIN/10.0D0
        XUR=REAL(XU)
        XM=0.5D0*(XO+XU)
        XMR=REAL(XM)
        XV1=0.5D0*(XU+XM)
        XV1R=REAL(XV1)
        XV2=0.5D0*(XO+XM)
        XV2R=REAL(XV2)
        IF (MOD(KOMP,2).EQ.1) THEN
        INT1=LC*(XO-XU)/6.0*(LFUNCT(XOR,PARM)/(XO**2-LC**2)+
     % LFUNCT(XUR,PARM)/(XU**2-LC**2)+4.0*LFUNCT(XMR,PARM)/
     % (XM**2-LC**2))
        INT2=LC*(XO-XU)/12.0*(LFUNCT(XOR,PARM)/(XO**2-LC**2)+
     % LFUNCT(XUR,PARM)/(XU**2-LC**2)+2.0*LFUNCT(XMR,PARM)/(XM**2-LC**2)
     % +4.0*LFUNCT(XV1R,PARM)/(XV1**2-LC**2)+4.0*LFUNCT(XV2R,PARM)/
     % (XV2**2-LC**2))
        ELSE
        INT1=-LC**2*(XO-XU)/6.0*(LFUNCT(XOR,PARM)/(XO*(XO**2-LC**2))+
     % LFUNCT(XUR,PARM)/(XU*(XU**2-LC**2))+4.0*LFUNCT(XMR,PARM)/(XM*
     % (XM**2-LC**2)))
        INT2=-LC**2*(XO-XU)/12.0*(LFUNCT(XOR,PARM)/(XO*(XO**2-LC**2))+
     % LFUNCT(XUR,PARM)/(XU*(XU**2-LC**2))+2.0*LFUNCT(XMR,PARM)/(XM*
     % (XM**2-LC**2))+4.0*LFUNCT(XV1R,PARM)/(XV1*(XV1**2-LC**2))+
     % 4.0*LFUNCT(XV2R,PARM)/(XV2*(XV2**2-LC**2)))
        ENDIF
        IF (INT1.EQ.INT2) THEN
        STEP=0.5D0*XO
        GOTO 200
        ENDIF
        STEP=0.1D0*(XO-XU)*(EPS/(ABS((INT1-INT2)/INT2)))**(1.0/3.0)
        STEP=DMIN1(0.5D0*XO,STEP)
C       CONTIBUTION FROM INFINITY
200     IF (MOD(KOMP,2).EQ.1) THEN
        LINT=0.0D0
        ELSE
        LINT=PARM(5)
        ENDIF
C       *************************************************************
C       INTEGRATION
C       *************************************************************
        XO=LMIN
        XOR=REAL(XO)
C       INTEGRATION LOOP
300     XU=XO-STEP
        XUR=REAL(XU)
        XM=0.5D0*(XO+XU)
        XMR=REAL(XM)
        IF (MOD(KOMP,2).EQ.1) THEN
        HINT=+LC*(XO-XU)/6.0D0*(LFUNCT(XOR,PARM)/(XO**2-LC**2)+
     % LFUNCT(XUR,PARM)/(XU**2-LC**2)+4.0D0*LFUNCT(XMR,PARM)/
     % (XM**2-LC**2))
        ELSE
        HINT=-LC**2*(XO-XU)/6.0D0*(LFUNCT(XOR,PARM)/(XO*(XO**2-LC**2))+
     % LFUNCT(XUR,PARM)/(XU*(XU**2-LC**2))+4.0D0*LFUNCT(XMR,PARM)/(XM*
     % (XM**2-LC**2)))
        ENDIF
        LINT=LINT+HINT
        STEP=STEP*(XU/XO)
        XO=XU
        XOR=REAL(XO)
        IF (DABS(HINT).GT.EPS*DABS(LINT)) GOTO 300
        ENDIF
        RETURN
        END

C       *************************************************************
C       INTEGRAL AT THE HIGH WAVELENGTH EDGE
C       *************************************************************
        REAL*8 FUNCTION RINT(KOMP,LC,LMAX,PARM)
        INTEGER KOMP,N,I
        REAL*8 LC,LMAX,INT1,INT2,HINT,C,B,D
        REAL*8 STEP,XU,XV1,XM,XV2,XO
        REAL XUR,XV1R,XMR,XV2R,XOR
        REAL PARM(6),EPS
        REAL RFUNCT
        DATA EPS /1.0E-7/

        IF (PARM(1).EQ.1.0) THEN
C       *************************************************************
C       ANALYTICAL INTEGRATION 
C       EXPONENT INTEGER GE 0
C       *************************************************************
        N=(-PARM(2))+1-MOD(KOMP,2)
        C=0.5D0*(1+(-1)**N)*LC**(-N)
        B=0.5D0*(1+(-1)**(N-1))*LC**(-N+1)
        D=0.0D0
        IF (N.LE.1) GOTO 110
        DO 100 I=0,(N-2)/2
100     D=D+LMAX**(-N+2*I+2)*LC**(-2*I)/(N-2*I-1)
        D=D/(LMAX*LC**2)
110     RINT=-PARM(3)*0.5D0*(-C/LC*DLOG((LMAX-LC)/(LMAX+LC))
     % +B/LC**2*DLOG(LMAX**2/(LMAX**2-LC**2))-2.0D0*D)
        IF (MOD(KOMP,2).EQ.1)THEN
        RINT=RINT+PARM(4)/(2.0D0*LC)*DLOG((LMAX-LC)/(LMAX+LC))
        RINT=-RINT*LC
        ELSE
        RINT=RINT-PARM(4)/(2.0D0*LC**2)*DLOG(LMAX**2/(LMAX**2-LC**2))
        RINT=RINT*LC**2
        ENDIF
        ELSE
C       ************************************************************
C       NUMERICAL INTEGRATION (SIMPSON RULE)
C       FOR NON-INTEGER EXPONENTS AND EXPONENTIAL FUNCTIONS
C       ************************************************************
C       SCHRITTWEITENABSCHAETZUNG
C       ************************************************************
        XU=LMAX
        XUR=REAL(XU)
        XO=LMAX+LMAX/10.0D0
        XOR=REAL(XO)
200     XM=0.5D0*(XO+XU)
        XMR=REAL(XM)
        XV1=0.5D0*(XU+XM)
        XV1R=REAL(XV1)
        XV2=0.5D0*(XO+XM)
        XV2R=REAL(XV2)
        IF (MOD(KOMP,2).EQ.1) THEN
        INT1=LC*(XO-XU)/6.0*(RFUNCT(XOR,PARM)/(XO**2-LC**2)+
     % RFUNCT(XUR,PARM)/(XU**2-LC**2)+4.0*RFUNCT(XMR,PARM)/
     % (XM**2-LC**2))
        INT2=LC*(XO-XU)/12.0*(RFUNCT(XOR,PARM)/(XO**2-LC**2)+
     % RFUNCT(XUR,PARM)/(XU**2-LC**2)+2.0*RFUNCT(XMR,PARM)/(XM**2-LC**2)
     % +4.0*RFUNCT(XV1R,PARM)/(XV1**2-LC**2)+4.0*RFUNCT(XV2R,PARM)/
     % (XV2**2-LC**2))
        ELSE
        INT1=-LC**2*(XO-XU)/6.0*(RFUNCT(XOR,PARM)/(XO*(XO**2-LC**2))+
     % RFUNCT(XUR,PARM)/(XU*(XU**2-LC**2))+4.0*RFUNCT(XMR,PARM)/(XM*
     % (XM**2-LC**2)))
        INT2=-LC**2*(XO-XU)/12.0*(RFUNCT(XOR,PARM)/(XO*(XO**2-LC**2))+
     % RFUNCT(XUR,PARM)/(XU*(XU**2-LC**2))+2.0*RFUNCT(XMR,PARM)/(XM*
     % (XM**2-LC**2))+4.0*RFUNCT(XV1R,PARM)/(XV1*(XV1**2-LC**2))+
     % 4.0*RFUNCT(XV2R,PARM)/(XV2*(XV2**2-LC**2)))
        ENDIF
        IF (INT1.EQ.INT2) THEN
        XO=XU+10.0*(XO-XU)
        XOR=REAL(XO)
        GOTO 200
        ENDIF
        STEP=0.1D0*(XO-XU)*(EPS/(ABS((INT1-INT2)/INT2)))**(1.0/3.0)
C       *************************************************************
C       INTEGRATION
C       *************************************************************
        XU=LMAX
        XUR=REAL(XU)
        RINT=0.0D0
C       INTEGRATION LOOP
300     XO=XU+STEP
        XOR=REAL(XO)
        XM=0.5D0*(XO+XU)
        XMR=REAL(XM)
        IF (MOD(KOMP,2).EQ.1) THEN
        HINT=LC*(XO-XU)/6.0D0*(RFUNCT(XOR,PARM)/(XO**2-LC**2)+
     % RFUNCT(XUR,PARM)/(XU**2-LC**2)+4.0D0*RFUNCT(XMR,PARM)/
     % (XM**2-LC**2))
        ELSE
        HINT=-LC**2*(XO-XU)/6.0D0*(RFUNCT(XOR,PARM)/(XO*(XO**2-LC**2))+
     % RFUNCT(XUR,PARM)/(XU*(XU**2-LC**2))+4.0D0*RFUNCT(XMR,PARM)/(XM*
     % (XM**2-LC**2)))
        ENDIF
        RINT=RINT+HINT
        STEP=STEP*XO/XU
        XU=XO
        XUR=REAL(XU)
        IF (DABS(HINT).GT.EPS*DABS(RINT)) GOTO 300
        ENDIF
        RETURN
        END


C       ***********************************************************
C       DETERMINES THE FIRST DERIVATIVE AT EACH POINT TO ENABLE
C       A SPLINE TREATMENT OF ALL INTERVALS
C       MODIFIED VERSION OF THE ROUTINE FROM NUMERICAL RECIPIES
C       ***********************************************************
      SUBROUTINE SPLINE(X,Y,N,Y2)
      REAL X(N),Y(N),Y2(N),U(512)
        REAL YN,SIG,P
        INTEGER N,I,K

        Y2(1)=0.
        U(1)=0.
      DO 11 I=2,N-1
        SIG=(X(I)-X(I-1))/(X(I+1)-X(I-1))
        P=SIG*Y2(I-1)+2.
        Y2(I)=(SIG-1.)/P
        U(I)=(6.*((Y(I+1)-Y(I))/(X(I+1)-X(I))-(Y(I)-Y(I-1))
     *      /(X(I)-X(I-1)))/(X(I+1)-X(I-1))-SIG*U(I-1))/P
11    CONTINUE
      Y2(N)=0.0
      DO 12 K=N-1,1,-1
        Y2(K)=Y2(K)*Y2(K+1)+U(K)
12    CONTINUE
      YN=Y2(N-1)
      DO 13 I=1,N-1
        Y2(I)=(Y(I+1)-Y(I))/(X(I+1)-X(I))-(X(I+1)-X(I))
     %  *(2.0*Y2(I)+Y2(I+1))/6.0
13    CONTINUE
      Y2(N)=(Y(N)-Y(N-1))/(X(N)-X(N-1))+YN*(X(N)-X(N-1))/6.0
      RETURN
      END
