C	*************************************************************
C	CALCULATION / MODIFICATION OF OPTICAL CONSTANTS
C	*************************************************************
	SUBROUTINE PARMMENU
	INTEGER KOMP
	REAL LPARM(6),RPARM(6)
	CHARACTER GC
	DATA LPARM /0.0,0.0,0.0,0.0,0.0,0.0/
	DATA RPARM /0.0,0.0,0.0,0.0,0.0,0.0/

11	FORMAT (A1)
12	FORMAT (//,' Correction of the extrapolation ? : ',$)
13	FORMAT (' Select special wavelength modus ? : ',$)

	KOMP=4
200	CALL LEXTRA(KOMP,LPARM)
	CALL REXTRA(KOMP,RPARM)
240	CALL EXGRAPH(KOMP,LPARM,RPARM)
	WRITE (6,12)
	READ (5,11) GC
	IF (GC.EQ.'Y'.OR.GC.EQ.'y') GOTO 200
	WRITE (6,13)
	READ (5,11) GC
	IF (GC.EQ.'Y'.OR.GC.EQ.'y') CALL WAVEMENU(KOMP,LPARM,RPARM)
230	CALL KKCALC(KOMP,LPARM,RPARM)
	RETURN
	END

C	*********************************************************
C	EXTRAPOLATION OF FUNCTIONS AT THE ENDS OF THE GIVEN
C	WAVELENGTH INTERVALL
C	*********************************************************
	SUBROUTINE LEXTRA(KOMP,PARM)
	INTEGER KOMP,FUNC
	REAL PARM(6)
	REAL L(256),CST(256,4)
	REAL LC,ALPHA,PIH,EKBR
	INTEGER M,N
	COMMON /OPTCST/ L,CST
	COMMON /ANZ/ M
	COMMON /KBR/ EKBR
	DATA PIH /1.570796/

10	FORMAT (///////////////////////////////////////////)
14	FORMAT (' Type 1-3 !')
16	FORMAT (18X,'Left end extrapolation menu',////)
17	FORMAT ('  Possible kinds of short wavelength extrapolation:')
19	FORMAT(/,'  (1) Lorentz/Drude in lambda->0 limit  (2 parameters)'
     %,/,'  (2) a*lambda^n+b behaviour            (3 parameters)',/,
     %'  (3) a*exp(-1/lambda)+b                (2 parameters)',//)
21	FORMAT (//,' Select your function :',$)
120	WRITE (6,10)
	WRITE (6,16)
	WRITE (6,17)
	WRITE (6,19)
130	WRITE (6,21)
	READ (5,*) FUNC
	GOTO (200,210,220) FUNC
	WRITE (6,14)
	GOTO 130
22	FORMAT (//,' Help:   f(lambdamin)=',E9.3,/)
23	FORMAT (' Short wavelength limit :',$)
24	FORMAT (' Exponent of decay (n) :',$)
25	FORMAT (' Constant term (b) :',$)
26	FORMAT (' Exponent must be above 0 !')
28	FORMAT (' Contribution from very small wavelengths, i.e.',
     %  ' e`(lambda->0) :',$)
200	LC=L(1)
	PARM(1)=1.0
	IF (MOD(KOMP,2).EQ.1) THEN
	PARM(2)=2.0
	WRITE (6,22) CST(1,KOMP)
	WRITE (6,23)
	READ (5,*) PARM(4)
	PARM(3)=(CST(1,KOMP)-PARM(4))/LC**2
	PARM(5)=0.0
	ELSE
	PARM(2)=3.0
	PARM(4)=0.0
	PARM(3)=CST(1,KOMP)/LC**3
	WRITE (6,28) 
	READ (5,*) PARM(5)
	PARM(5)=(PARM(5)/EKBR-1.0)/(PARM(5)/EKBR+2.0)*PIH
	ENDIF
	GOTO 100
210	LC=L(1)
	WRITE (6,24)
	READ (5,*) ALPHA
	IF (ALPHA.GT.0.0) GOTO 215
	WRITE (6,26)
	CALL SMLPAUSE
	GOTO 120
215	N=NINT(ALPHA)
	IF (ABS(ALPHA-N).LT.1E-3) THEN
	PARM(1)=1.0
	PARM(2)=N
	ELSE
	PARM(1)=2.0
	PARM(2)=ALPHA
	ENDIF
	IF (MOD(KOMP,2).EQ.1) THEN
	WRITE (6,22) CST(1,KOMP)
	WRITE (6,25)
	READ (5,*) PARM(4)
	PARM(5)=0.0
	ELSE
	PARM(4)=0.0
	WRITE (6,28)
	READ (5,*) PARM(5)
	PARM(5)=(PARM(5)/EKBR-1.0)/(PARM(5)/EKBR+2.0)*PIH
	ENDIF
	PARM(3)=(CST(1,KOMP)-PARM(4))/LC**PARM(2)
	GOTO 100
220	LC=L(1)
	PARM(1)=3.0
	PARM(2)=0.0
	IF (MOD(KOMP,2).EQ.1) THEN
	WRITE (6,22) CST(1,KOMP)
	WRITE (6,25)
	READ (5,*) PARM(4)
	PARM(5)=0.0
	ELSE
	PARM(4)=0.0
	WRITE (6,28)
	READ (5,*) PARM(5)
	PARM(5)=(PARM(5)/EKBR-1.0)/(PARM(5)/EKBR+2.0)*PIH
	ENDIF
	PARM(3)=(CST(1,KOMP)-PARM(4))/EXP(-1.0/LC)
100	RETURN
	END

C	*********************************************************
C	EXTRAPOLATION OF FUNCTIONS AT THE ENDS OF THE GIVEN
C	WAVELENGTH INTERVALL
C	*********************************************************
	SUBROUTINE REXTRA(KOMP,PARM)
	INTEGER KOMP,FUNC
	REAL PARM(6)
	REAL L(256),CST(256,4)
	REAL LC,ALPHA
	INTEGER M,N
	COMMON /OPTCST/ L,CST
	COMMON /ANZ/ M

10      FORMAT (////////////////////////////////////////////)
14	FORMAT (' Type 1-3 !')
16	FORMAT (18X,'Right end extrapolation menu',////)
17	FORMAT ('  Possible kinds of long wavelength extrapolation:')
19	FORMAT (/,'  (1) Lorentz in lambda-> limit    (1 parameter)',/,
     %'  (2) a*lambda^(-n)+b behaviour     (3 parameters)',/,
     %'  (3) a*exp(-lambda)+b              (2 parameters)',//)
21	FORMAT (//,' Select your function :',$)
120	WRITE (6,10)
	WRITE (6,16)
	WRITE (6,17)
	WRITE (6,19)
130	WRITE (6,21)
	READ (5,*) FUNC
	GOTO (200,210,220) FUNC
	WRITE (6,14)
	GOTO 130
22	FORMAT (//,' Help: f(lambdamax)=',E9.3,/)
23	FORMAT (//,' Long wavelength limit :',$)
24	FORMAT (//,' Exponent of decay (n) :',$)
25	FORMAT (' Constant term (b) :',$)
26	FORMAT (' Exponent must be above -1 !')
27	FORMAT (' Exponent must be above -2 !')
200	LC=L(M)
	PARM(1)=1.0
	IF (MOD(KOMP,2).EQ.1) THEN
	PARM(2)=0.0
	PARM(3)=0.0
	PARM(4)=CST(M,KOMP)
	ELSE
	PARM(2)=-1.0
	PARM(4)=0.0
	PARM(3)=CST(M,KOMP)*LC
	ENDIF
	GOTO 100	
210	LC=L(M)
	WRITE (6,24)
	READ (5,*) ALPHA
	IF (MOD(KOMP,2).EQ.1.AND.ALPHA.LE.(-1.0)) THEN
	WRITE (6,26)
	CALL SMLPAUSE
	GOTO 120
	ELSE IF (MOD(KOMP,2).EQ.0.AND.ALPHA.LE.(-2.0)) THEN
	WRITE (6,27)
	CALL SMLPAUSE
	GOTO 120
	ENDIF
215	N=NINT(ALPHA)
	IF (ABS(ALPHA-N).LT.1E-3) THEN
	PARM(1)=1.0
	PARM(2)=-N
	ELSE
	PARM(1)=2.0
	PARM(2)=-ALPHA
	ENDIF
	WRITE (6,22) CST(M,KOMP)
	WRITE (6,25)
	READ (5,*) PARM(4)
	PARM(3)=(CST(M,KOMP)-PARM(4))/LC**PARM(2)
	GOTO 100
220	LC=L(M)
	PARM(1)=3.0
	PARM(2)=0.0
	WRITE (6,22) CST(M,KOMP)
	WRITE (6,25)
	READ (5,*) PARM(4)
	PARM(3)=(CST(M,KOMP)-PARM(4))/EXP(-LC)
100	RETURN
	END

C	***********************************************************
C	ROUTINES TO INPUT NUMBER AND DENSITY OF WAVELENGTH POINTS
C	***********************************************************
	SUBROUTINE WAVEMENU(KOMP,LPARM,RPARM)
	INTEGER KOMP,FUNC
	REAL LPARM(6),RPARM(6)
	LOGICAL IFLG,IFZ

10      FORMAT (////////////////////////////////)
13	FORMAT (23X,'Wavelengths modus menu',////)
15	FORMAT ('  Use a linear scaling      :   (1) in wavelengths',5X,
     % '(2) in wavenumbers',/,'  Use a logarithmic scaling :   (3) in wa
     %velengths',5X,'(4) in wavenumbers',/,/)
16	FORMAT (' Select your function :',$)
17	FORMAT (' Type 0-4!')
C	*************************************************************
C	TEST IF A WAVELENGHTS RANGE IS GIVEN
C	*************************************************************
100	WRITE (6,10)
	WRITE (6,13)
	WRITE (6,15)
130	WRITE (6,16)
	READ (5,*) FUNC
	IF(FUNC.GT.0.AND.FUNC.LT.5) GOTO 200
	IF(FUNC.EQ.0) RETURN
	WRITE (6,17)
	GOTO 130
200	IFLG=(FUNC.GT.2)
	IFZ=(MOD(FUNC,2).EQ.0)
	IF(IFZ) THEN
	CALL ZSCALE(KOMP,LPARM,RPARM,IFLG)
	ELSE
	CALL WAVESCAL(KOMP,LPARM,RPARM,IFLG)
	ENDIF
	RETURN
	END

C	*************************************************************
C	ROUTINE TO CHOSE THE SCALING IN WAVELENGTHS
C	*************************************************************
	SUBROUTINE WAVESCAL(KOMP,LPARM,RPARM,IFLG)
	INTEGER KOMP,NSTEP
	INTEGER M
	LOGICAL IFLG
	REAL LHLP,LSTA,LSTP,LC
	REAL LPARM(6),RPARM(6)
	REAL L(256),CST(256,4),TEMPCST(256),TEMPWAVE(256)
	REAL LFUNCT,RFUNCT,VALUEAT
	INTEGER I,NINH
	COMMON /OPTCST/ L,CST
	COMMON /ANZ/ M

200	WRITE (6,21)
21      FORMAT (//////////////////////////////////////////)
22	FORMAT (' Minimum wavelength =',1PE10.3,' cm')
23	FORMAT (' Log(min.wavelength)=',1PE10.3)
24	FORMAT (' Starting point =',$)
25	FORMAT (' Stepwidth =',$)
28	FORMAT (' Number of steps =',$)
26	FORMAT (' Maximum wavelength =',1PE10.3,' cm')
31	FORMAT (' Log(max.wavelength)=',1PE10.3)
35	FORMAT (' You cannot require more than 256 steps !')
36      FORMAT (' Range covered by the chosen scaling:')
	WRITE (6,22) L(1)
	IF (IFLG) WRITE(6,23) ALOG10(L(1))
        WRITE (6,26) L(M)
        IF (IFLG) WRITE(6,31) ALOG10(L(M))
	WRITE (6,24)
	READ (5,*) LSTA
	WRITE (6,25)
	READ (5,*) LSTP
	WRITE (6,28)
	READ (5,*) NSTEP
	IF(NSTEP.LE.256) GOTO 210
	WRITE (6,35)
	CALL SMLPAUSE
	GOTO 200
C	*************************************************************
C	TEMPORARY STORAGE OF GIVEN CONSTANTS
C	*************************************************************
210	DO 290 I=1,M
	TEMPCST(I)=CST(I,KOMP)
290	TEMPWAVE(I)=L(I)
	IF (IFLG) THEN
C	*************************************************************
C	LOGARITHMIC SCALING
C	*************************************************************
	LHLP=10.0**LSTA
	DO 320 I=1,NSTEP
	L(I)=LHLP
	LSTA=LSTA+LSTP
	LHLP=10.0**LSTA
320	CONTINUE
	ELSE
C	*************************************************************
C	LINEAR SCALING
C	*************************************************************
	DO 220 I=1,NSTEP
	L(I)=LSTA
	LSTA=LSTA+LSTP
220	CONTINUE
	ENDIF
C	*************************************************************
C	CALCULATE ACCORDING CONSTANTS
C	*************************************************************
	NINH=1
	DO 240 I=1,NSTEP
	LC=L(I)
	WRITE (6,*) LC
	IF (LC.LT.TEMPWAVE(1)) THEN
	CST(I,KOMP)=LFUNCT(LC,LPARM)
	ELSE IF (LC.GT.TEMPWAVE(M)) THEN
	CST(I,KOMP)=RFUNCT(LC,RPARM)
	ELSE
	CST(I,KOMP)=VALUEAT(TEMPWAVE,TEMPCST,LC,NINH)
	ENDIF
240	CONTINUE
	M=NSTEP
        WRITE (6,36)
        WRITE (6,22) L(1)
        IF(IFLG) WRITE(6,23) ALOG10(L(1))
        WRITE (6,26) L(M)
        IF(IFLG) WRITE(6,31) ALOG10(L(M))
        CALL SMLPAUSE
	RETURN
	END

C	*************************************************************
C	ROUTINE TO CHOSE THE SCALING IN WAVENUMBERS
C	*************************************************************
	SUBROUTINE ZSCALE(KOMP,LPARM,RPARM,IFLG)
	INTEGER KOMP,NSTEP
	INTEGER M
	LOGICAL IFLG
	REAL LHLP,LSTA,LSTP,ZMIN,ZMAX,LC
	REAL LPARM(6),RPARM(6)
	REAL L(256),CST(256,4),TEMPCST(256),TEMPWAVE(256)
	REAL LFUNCT,RFUNCT,VALUEAT
	INTEGER I,NINH
	COMMON /OPTCST/ L,CST
	COMMON /ANZ/ M

200	WRITE (6,21)
21      FORMAT (//////////////////////////////////////////)
22	FORMAT (' Minimum wavenumber =',1PE10.3,' cm^-1')
23	FORMAT (' Log(min.wavenumber)=',1PE10.3)
24	FORMAT (' Starting point =',$)
25	FORMAT (' Stepwidth =',$)
28	FORMAT (' Number of steps =',$)
27	FORMAT (' Maximum wavenumber =',1PE10.3,' cm^-1')
29	FORMAT (' Log(max.wavenumber)=',1PE10.3)
26	FORMAT (' Minimal wavenumber must be not equal to 0 !')
35	FORMAT (' You cannot require more than 256 steps !')
36      FORMAT (' Range covered by the chosen scaling:')
	ZMIN=1.0/L(M)
        ZMAX=1.0/L(1)
	WRITE (6,22) ZMIN
	IF (IFLG) WRITE(6,23) ALOG10(ZMIN)
        WRITE (6,27) ZMAX
        IF (IFLG) WRITE(6,29) ALOG10(ZMAX)
120	WRITE (6,24)
	READ (5,*) LSTA
	IF (LSTA.EQ.0.0.AND..NOT.IFLG) THEN
	WRITE (5,26)
	GOTO 120
	ENDIF
	WRITE (6,25)
	READ (5,*) LSTP
	WRITE (6,28) 
	READ (5,*) NSTEP
	IF(NSTEP.LE.256) GOTO 210
	WRITE (6,35)
	CALL SMLPAUSE
	GOTO 200
C	*************************************************************
C	TEMPORARY STORAGE OF GIVEN CONSTANTS
C	*************************************************************
210	DO 290 I=1,M
	TEMPCST(I)=CST(I,KOMP)
290	TEMPWAVE(I)=L(I)
C	*************************************************************
C	LOGARITHMIC SCALING
C	*************************************************************
	IF (IFLG) THEN
	LHLP=10.0**(-LSTA)
	DO 320 I=NSTEP,1,-1
	L(I)=LHLP
	LSTA=LSTA+LSTP
	LHLP=10.0**(-LSTA)
320	CONTINUE
	ELSE
C	*************************************************************
C	LINEAR SCALING
C	*************************************************************
	DO 220 I=NSTEP,1,-1
	L(I)=1.0/LSTA
	LSTA=LSTA+LSTP
220	CONTINUE
	ENDIF
C	*************************************************************
C	CALCULATE ACCORDING CONSTANTS
C	*************************************************************
	NINH=1
	DO 240 I=1,NSTEP
	LC=L(I)
	WRITE (6,*) LC
	IF (LC.LT.TEMPWAVE(1)) THEN
	CST(I,KOMP)=LFUNCT(LC,LPARM)
	ELSE IF (LC.GT.TEMPWAVE(M)) THEN
	CST(I,KOMP)=RFUNCT(LC,RPARM)
	ELSE
	CST(I,KOMP)=VALUEAT(TEMPWAVE,TEMPCST,LC,NINH)
	ENDIF
240	CONTINUE
	M=NSTEP
        WRITE (6,36)
        WRITE (6,22) 1.0/L(M)
        IF (IFLG) WRITE(6,23) -ALOG10(L(M))
        WRITE (6,27) 1.0/L(1)
        IF (IFLG) WRITE(6,29) -ALOG10(L(1))
        CALL SMLPAUSE
	RETURN
	END

